/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "aiptekdriverclass.h"

aiptekDriverClass::aiptekDriverClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :aiptekDriverDialog(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
if (x->getOption("InputDevice", sectNum, "Type") == "stylus") { kComboBox1->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "Type") == "eraser") { kComboBox1->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "Type") == "cursor") { kComboBox1->setCurrentItem(2); }
if (x->getOption("InputDevice", sectNum, "Mode") == "Relative") { kComboBox1_2->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "Mode") == "Absolute") { kComboBox1_2->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "Pressure") == "soft") { kComboBox1_2_2->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "Pressure") == "hard") { kComboBox1_2_2->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "Pressure") == "linear") { kComboBox1_2_2->setCurrentItem(2); }
kLineEdit1->setText(x->getOption("InputDevice", sectNum, "DeviceName"));
if (x->checkOption("InputDevice", sectNum, "KeepShape")) { checkBox28->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "AlwaysCore")) { checkBox1_2->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "USB")) { checkBox1->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "InvX")) { checkBox1_3->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "InvY")) { checkBox1_3_2->setChecked(TRUE); }


if (x->getOption("InputDevice", sectNum ,"XTop") != "")
{
groupBox4->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"XTop").toInt(&ok, 10);
kIntSpinBox8->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"YTop") != "")
{
groupBox4->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"YTop").toInt(&ok, 10);
kIntSpinBox8_2->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"XBottom") != "")
{
groupBox4->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"XBottom").toInt(&ok, 10);
kIntSpinBox8_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"YBottom") != "")
{
groupBox4->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"YBottom").toInt(&ok, 10);
kIntSpinBox8_2_2->setValue(a);
}


if (x->getOption("InputDevice", sectNum ,"XMax") != "")
{
groupBox5->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"XMax").toInt(&ok, 10);
kIntSpinBox8_3_2->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"YMax") != "")
{
groupBox5->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"YMax").toInt(&ok, 10);
kIntSpinBox8_2_2_2->setValue(a);
}





if (x->getOption("InputDevice", sectNum ,"XOffset") != "")
{
groupBox4_2->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"XOffset").toInt(&ok, 10);
kIntSpinBox8_4->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"YOffset") != "")
{
groupBox4_2->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"YOffset").toInt(&ok, 10);
kIntSpinBox8_2_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"XSize") != "")
{
groupBox4_2->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"XSize").toInt(&ok, 10);
kIntSpinBox8_3_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"YSize") != "")
{
groupBox4_2->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"YSize").toInt(&ok, 10);
kIntSpinBox8_2_2_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"HistorySize") != "")
{
checkBox21->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"HistorySize").toInt(&ok, 10);
kIntSpinBox6->setValue(a);
}


if (x->getOption("InputDevice", sectNum ,"DebugLevel") != "")
{
checkBox22->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"DebugLevel").toInt(&ok, 10);
kIntSpinBox6_2->setValue(a);
}



if (x->getOption("InputDevice", sectNum ,"ZMin") != "")
{
minZPressure->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"ZMin").toInt(&ok, 10);
minZSpin->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"ZMax") != "")
{
maxZPressure->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"ZMax").toInt(&ok, 10);
maxZSpin->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"XThreshold") != "")
{
XThreshold->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"XThreshold").toInt(&ok, 10);
XThreSpin->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"YThreshold") != "")
{
YThreshold->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"YThreshold").toInt(&ok, 10);
YThreSpin->setValue(a);
}

if (x->getOption("InputDevice", sectNum ,"ZThreshold") != "")
{
ZThreshold->setChecked(TRUE);
bool ok;
int a = x->getOption("InputDevice", sectNum ,"ZThreshold").toInt(&ok, 10);
ZThreSpin->setValue(a);
}







}


QString aiptekDriverClass :: returnXorg()
{
return x->returnConfig();
}

void aiptekDriverClass::firstSet()
{
if (groupBox4->isChecked())
{
groupBox5->setChecked(FALSE);
groupBox4_2->setChecked(FALSE);
}
}

void aiptekDriverClass::secondSet()
{
if (groupBox5->isChecked())
{
groupBox4->setChecked(FALSE);
groupBox4_2->setChecked(FALSE);
}

}

void aiptekDriverClass::thirdSet()
{
if (groupBox4_2->isChecked())
{
groupBox4->setChecked(FALSE);
groupBox5->setChecked(FALSE);
}

}

void aiptekDriverClass::maxZPressureCheck()
{
if (maxZPressure->isChecked()) { maxZSpin->setEnabled(TRUE); }
if (!maxZPressure->isChecked()) { maxZSpin->setEnabled(FALSE); }
}


void aiptekDriverClass::minZPressureCheck()
{
if (minZPressure->isChecked()) { minZSpin->setEnabled(TRUE); }
if (!minZPressure->isChecked()) { minZSpin->setEnabled(FALSE); }
}

void aiptekDriverClass::XThreCheck()
{
if (XThreshold->isChecked()) { XThreSpin->setEnabled(TRUE); }
if (!XThreshold->isChecked()) { XThreSpin->setEnabled(FALSE); }
}

void aiptekDriverClass::YThreCheck()
{
if (YThreshold->isChecked()) { YThreSpin->setEnabled(TRUE); }
if (!YThreshold->isChecked()) { YThreSpin->setEnabled(FALSE); }
}

void aiptekDriverClass::ZThreCheck()
{
if (ZThreshold->isChecked()) { ZThreSpin->setEnabled(TRUE); }
if (!ZThreshold->isChecked()) { ZThreSpin->setEnabled(FALSE); }
}

void aiptekDriverClass::historyCheck()
{

if (checkBox21->isChecked()) { kIntSpinBox6->setEnabled(TRUE); }
if (!checkBox21->isChecked()) { kIntSpinBox6->setEnabled(FALSE); }

}

void aiptekDriverClass::debugCheck()
{
if (checkBox22->isChecked()) { kIntSpinBox6_2->setEnabled(TRUE); }
if (!checkBox22->isChecked()) { kIntSpinBox6_2->setEnabled(FALSE); }

}



void aiptekDriverClass :: accept()
{

if (kComboBox1->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "Type", 1, "stylus"); }
if (kComboBox1->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Type", 1, "eraser"); }
if (kComboBox1->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "Type", 1, "cursor"); }
if (kComboBox1_2->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "Mode", 1, "Relative"); }
if (kComboBox1_2->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Mode", 1, "Absolute"); }
if (kComboBox1_2_2->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "Pressure", 1, "soft"); }
if (kComboBox1_2_2->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Pressure", 1, "hard"); }
if (kComboBox1_2_2->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "Pressure", 1, "linear"); }

if (kLineEdit1->text() == "") 
{
x->removeOption("InputDevice", sectNum, "DeviceName");
}
if (kLineEdit1->text() != "") 
{
x->saveOption("InputDevice", sectNum, "DeviceName", 1, kLineEdit1->text());
}

if (checkBox28->isChecked()) { x->saveOption("InputDevice", sectNum, "KeepShape", 1, "True"); }
if (!checkBox28->isChecked()) { x->removeOption("InputDevice", sectNum, "KeepShape"); }
if (checkBox1_2->isChecked()) { x->saveOption("InputDevice", sectNum, "AlwaysCore", 1, "True"); }
if (!checkBox1_2->isChecked()) { x->removeOption("InputDevice", sectNum, "AlwaysCore"); }
if (checkBox1->isChecked()) { x->saveOption("InputDevice", sectNum, "USB", 1, "True"); }
if (!checkBox1->isChecked()) { x->removeOption("InputDevice", sectNum, "USB"); }
if (checkBox1_3->isChecked()) { x->saveOption("InputDevice", sectNum, "InvX", 1, "True"); }
if (!checkBox1_3->isChecked()) { x->removeOption("InputDevice", sectNum, "InvX"); }
if (checkBox1_3_2->isChecked()) { x->saveOption("InputDevice", sectNum, "InvY", 1, "True"); }
if (!checkBox1_3_2->isChecked()) { x->removeOption("InputDevice", sectNum, "InvY"); }


if (!groupBox4->isChecked())
{
x->removeOption("InputDevice", sectNum, "XTop");
x->removeOption("InputDevice", sectNum, "YTop");
x->removeOption("InputDevice", sectNum, "XBottom");
x->removeOption("InputDevice", sectNum, "YBottom");
}

if (groupBox4->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox8->value(), 10);
x->saveOption("InputDevice", sectNum, "XTop", 1, num);
num = num.setNum(kIntSpinBox8_2->value(), 10);
x->saveOption("InputDevice", sectNum, "YTop", 1, num);
num = num.setNum(kIntSpinBox8_3->value(), 10);
x->saveOption("InputDevice", sectNum, "XBottom", 1, num);
num = num.setNum(kIntSpinBox8_2_2->value(), 10);
x->saveOption("InputDevice", sectNum, "YBottom", 1, num);
}


if (!groupBox5->isChecked())
{
x->removeOption("InputDevice", sectNum, "XMax");
x->removeOption("InputDevice", sectNum, "YMax");
}


if (groupBox5->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox8_3_2->value(), 10);
x->saveOption("InputDevice", sectNum, "XMax", 1, num);
num = num.setNum(kIntSpinBox8_2_2_2->value(), 10);
x->saveOption("InputDevice", sectNum, "YMax", 1, num);

}




if (!groupBox4_2->isChecked())
{
x->removeOption("InputDevice", sectNum, "XOffset");
x->removeOption("InputDevice", sectNum, "YOffset");
x->removeOption("InputDevice", sectNum, "XSize");
x->removeOption("InputDevice", sectNum, "YSize");
}

if (groupBox4_2->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox8_4->value(), 10);
x->saveOption("InputDevice", sectNum, "XOffset", 1, num);
num = num.setNum(kIntSpinBox8_2_3->value(), 10);
x->saveOption("InputDevice", sectNum, "YOffset", 1, num);
num = num.setNum(kIntSpinBox8_3_3->value(), 10);
x->saveOption("InputDevice", sectNum, "XSize", 1, num);
num = num.setNum(kIntSpinBox8_2_2_3->value(), 10);
x->saveOption("InputDevice", sectNum, "YSize", 1, num);
}
if (checkBox21->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox6->value());
x->saveOption("InputDevice", sectNum, "HistorySize", 1, num);
}

if (!checkBox21->isChecked())
{
x->removeOption("InputDevice", sectNum, "HistorySize");
}


if (checkBox22->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox6_2->value());
x->saveOption("InputDevice", sectNum, "DebugLevel", 1, num);
}
if (!checkBox22->isChecked())
{
x->removeOption("InputDevice", sectNum, "DebugLevel");
}




if (minZPressure->isChecked())
{
QString num;
num = num.setNum(minZSpin->value());
x->saveOption("InputDevice", sectNum, "ZMin", 1, num);
}

if (!minZPressure->isChecked())
{
x->removeOption("InputDevice", sectNum, "ZMin");
}

if (maxZPressure->isChecked())
{
QString num;
num = num.setNum(maxZSpin->value());
x->saveOption("InputDevice", sectNum, "ZMax", 1, num);
}

if (!maxZPressure->isChecked())
{
x->removeOption("InputDevice", sectNum, "ZMax");
}

if (XThreshold->isChecked())
{
QString num;
num = num.setNum(XThreSpin->value());
x->saveOption("InputDevice", sectNum, "XThreshold", 1, num);
}

if (!XThreshold->isChecked())
{
x->removeOption("InputDevice", sectNum, "XThreshold");
}

if (YThreshold->isChecked())
{
QString num;
num = num.setNum(YThreSpin->value());
x->saveOption("InputDevice", sectNum, "YThreshold", 1, num);
}

if (!YThreshold->isChecked())
{
x->removeOption("InputDevice", sectNum, "YThreshold");
}

if (ZThreshold->isChecked())
{
QString num;
num = num.setNum(ZThreSpin->value());
x->saveOption("InputDevice", sectNum, "ZThreshold", 1, num);
}

if (!ZThreshold->isChecked())
{
x->removeOption("InputDevice", sectNum, "ZThreshold");
}






























close();
}










#include "aiptekdriverclass.moc"
