/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "jsxdriverclass.h"

jsxDriverClass::jsxDriverClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :jsxDriverDialog(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
bool ok;


if (x->getOption("InputDevice", sectNum, "MinX") != "")
{
int a = x->getOption("InputDevice", sectNum, "MinX").toInt(&ok, 10);
kIntSpinBox6->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MaxX") != "")
{
int a = x->getOption("InputDevice", sectNum, "MaxX").toInt(&ok, 10);
kIntSpinBox6_2->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MinY") != "")
{
int a = x->getOption("InputDevice", sectNum, "MinY").toInt(&ok, 10);
kIntSpinBox6_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MaxY") != "")
{
int a = x->getOption("InputDevice", sectNum, "MaxY").toInt(&ok, 10);
kIntSpinBox6_2_2->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "PressMin") != "")
{
int a = x->getOption("InputDevice", sectNum, "PressMin").toInt(&ok, 10);
kIntSpinBox6_4->setValue(a);
}
if (x->getOption("InputDevice", sectNum, "PressMax") != "")
{
int a = x->getOption("InputDevice", sectNum, "PressMax").toInt(&ok, 10);
kIntSpinBox6_2_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "PressDiv") != "")
{
int a = x->getOption("InputDevice", sectNum, "PressDiv").toInt(&ok, 10);
kIntSpinBox6_2_3_2->setValue(a);
}
}



void jsxDriverClass :: accept()
{
QString num;
num = num.setNum(kIntSpinBox6->value(), 10);
x->saveOption("InputDevice", sectNum, "MinX", 1, num);
num = num.setNum(kIntSpinBox6_2->value(), 10);
x->saveOption("InputDevice", sectNum, "MaxX", 1, num);
num = num.setNum(kIntSpinBox6_3->value(), 10);
x->saveOption("InputDevice", sectNum, "MinY", 1, num);
num = num.setNum(kIntSpinBox6_2_2->value(), 10);
x->saveOption("InputDevice", sectNum, "MaxY", 1, num);

num = num.setNum(kIntSpinBox6_4->value(), 10);
x->saveOption("InputDevice", sectNum, "PressMin", 1, num);
num = num.setNum(kIntSpinBox6_2_3->value(), 10);
x->saveOption("InputDevice", sectNum, "PressMax", 1, num);
num = num.setNum(kIntSpinBox6_2_3_2->value(), 10);
x->saveOption("InputDevice", sectNum, "PressDiv", 1, num);
close();
}



QString jsxDriverClass :: returnXorg()
{
return x->returnConfig();
}


#include "jsxdriverclass.moc"
