/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kxmain.h"

#include "debugwindowinformation.h"
#include "dpmsglobaldialog.h"
#include "gammadialogclass.h"
#include "advancedserverflagsclass.h"
#include "aboutdialogwindow.h"
#include "kbdoptionsdialog.h"
#include "mousedriverdialog.h"
#include "nvidiadriveroptionsbigdialog.h"
#include "advancedmonitordialogclass.h"
#include "wacomdrvdialogclass.h"
#include "nvdriverdialogclass.h"
#include "vesadialogclass.h"
#include "fbdevdialogclass.h"
#include "viadriverclass.h"
#include "helpboxinformation.h"
#include "tk4957dialogoptions.h"
#include "aiptekdriverclass.h"
#include "elographicsdriverclass.h"
#include "fpitdriverclass.h"
#include "jsxdriverclass.h"

#include <iostream.h>


kxMain::kxMain(QWidget *parent, const char *name)
    :Form1(parent, name)
{
x = new xorgConf();

initCheckboxes();
setLocale();
srvInputsPrepare();
fillVideocard();
fillMonitor();
fillModules();
fillFiles();
fillMouseKbd();
fillScreenCombos();
fillScreen();
fillServerLayout();
connect (DefaultServerLayoutContainer, SIGNAL(toggled(bool)), this, SLOT(defSrvLayContChange()));
//debugButton->hide();
}

void kxMain :: fillModules()
{
QString bb;
int a = 1;
while (a > -1)
{
bb = x->getValue("Module", 1, "Load", a);
if (bb == "") { break; }
modulesBox->insertItem(bb);
moduleComboBox->insertItem(bb);
a++;
}
modulesBox->setSelected(0, TRUE);
}

void kxMain :: fillVideocard()
{


QString toAdd = x->getValue("Device", videoSpinBox->value(), "Identifier", 1);
QString numAdd;
videoIdentEdit->setText(toAdd);
numAdd = numAdd.setNum(videoSpinBox->value(), 10);



toAdd = x->getValue("Device", videoSpinBox->value(), "Vendor", 1);
videoVendorEdit->setText(toAdd);
int a = 0;
while (a < videoComboBox->count())
{
if (videoComboBox->text(a).section(" - ", 0, 0) == x->getValue("Device", videoSpinBox->value(), "Driver", 1)) { break; }
a++;
if (a == videoComboBox->count()) { a = 65535; break; }
}
if (a < videoComboBox->count()) { 
videoComboBox->setCurrentItem(a); 
}
if (a == 65535) 
{
videoComboBox->insertItem(x->getValue("Device", videoSpinBox->value(), "Driver", 1).append(tr(" - unknown driver")));
videoComboBox->setCurrentItem(videoComboBox->count() - 1);
}

numAdd = numAdd.setNum(x->sectionCount("Device"));
videoSpinBox->setMaxValue(x->sectionCount("Device"));


QString label;
QString num;
if (x->sectionCount("Device") == 1) { label = " entry"; }
if (x->sectionCount("Device") > 1) { label = " entries"; }

num = num.setNum(x->sectionCount("Device"), 10);
label = label.prepend(num);
videoEntriesLabel->setText(label);

}

void kxMain :: fillMonitor()
{

if (x->section("Monitor", monitorSpinBox->value()).contains("Option \"DPMS\"") > 0) 
{ 
x->removeOption("Monitor", monitorSpinBox->value(), "DPMS");
x->saveOption("Monitor", monitorSpinBox->value(), "DPMS", 1, "True");
checkBox16->setChecked(TRUE);
}
if (x->section("Monitor", monitorSpinBox->value()).contains("Option \"DPMS\"") == 0) 
{ 
x->removeOption("Monitor", monitorSpinBox->value(), "DPMS");
checkBox16->setChecked(FALSE);
}


monitorSpinBox->setMaxValue(x->sectionCount("Monitor"));
QString numAdd;
numAdd = numAdd.setNum(monitorSpinBox->value(), 10);
QString toAdd;

toAdd = x->getValue("Monitor", monitorSpinBox->value(), "Identifier", 1);
monitorIdentEdit->setText(toAdd);

toAdd = x->getValue("Monitor", monitorSpinBox->value(), "ModelName", 1);
monitorModelEdit->setText(toAdd);

toAdd = x->getValue("Monitor", monitorSpinBox->value(), "VendorName", 1);
monitorVendorEdit->setText(toAdd);



QString label;
QString num;
if (x->sectionCount("Monitor") == 1) { label = locRet(17); }
if (x->sectionCount("Monitor") > 1) { label = locRet(18); }

num = num.setNum(x->sectionCount("Monitor"), 10);
label = label.prepend(num);
monitorEntriesLabel->setText(label);

}

void kxMain :: fillFiles()
{

QString buf = x->getValue("Files", 1, "RgbPath", 1);
int a = 1;

if (buf == "") { rgbGroupBox->setChecked(FALSE); }
if (buf != "") { rgbGroupBox->setChecked(TRUE); RGBPathRequester->setURL(buf); }

QString modList = "";
QString fontsList = "";

while (a > - 1)
{
if (x->getValue("Files", 1, "FontPath", a) == "") { break; }
fontsList = fontsList.append(x->getValue("Files", 1, "FontPath", a)).append(",");
a++;
}
fontsList = fontsList.replace(",", " | ");

a = 1;
while (a > - 1)
{
if (x->getValue("Files", 1, "ModulePath", a) == "") { break; }
modList = modList.append(x->getValue("Files", 1, "ModulePath", a)).append(",");
a++;
}
modList = modList.replace(",", " | ");


if (fontsList != "")
{
fontsGroupBox->setChecked(TRUE);
a = 0;
while (a > -1)
{
if (fontsList.section(" | ", a, a) == "") { break; }
fontsBox->insertItem(fontsList.section(" | ", a, a));
a++;
}
fontsBox->setSelected(0, TRUE);
}


if (modList != "")
{
modulesPathGroupBox->setChecked(TRUE);
a = 0;
while (a > -1)
{
if (modList.section(" | ", a, a) == "") { break; }
modulesPathListBox->insertItem(modList.section(" | ", a, a));
a++;
}
modulesPathListBox->setSelected(0, TRUE);
}
}

void kxMain :: fillServerLayout()
{
listBox16->clear();
int a = 1;
while (a <= x->sectionCount("ServerLayout"))
{
listBox16->insertItem(x->getValue("ServerLayout", a, "Identifier", 1));
a++;
}
listBox16->setSelected(0, TRUE);
}

void kxMain :: aboutDialog()
{
aboutDialogWindow *about = new aboutDialogWindow();
about->show();

}

void kxMain :: showDebug()
{
debugWindowInformation *debug = new debugWindowInformation(this, "Debug Window", x->returnConfig());
debug->exec();
}

void kxMain :: removeDevice()
{
if (x->sectionCount("Device") == 1)
{
QMessageBox::warning(this, "kX Generator", locRet(19));
return;
}

if (x->sectionCount("Device") > 1)
{
x->removeSection("Device", videoSpinBox->value());
fillVideocard();
fillScreenCombos();
}

}

void kxMain :: addDevice()
{
x->addSection("Device");
x->saveValue("Device", videoSpinBox->maxValue() + 1, "Driver", 1, "apm");
fillVideocard();
videoSpinBox->setValue(videoSpinBox->maxValue());
QString num;
num = num.setNum(videoSpinBox->value(), 10);
videoIdentEdit->setText("Device" + num);
fillScreenCombos();
}

void kxMain :: addMonitor()
{
x->addSection("Monitor");
fillMonitor();
monitorSpinBox->setValue(monitorSpinBox->maxValue());
QString num;
num = num.setNum(monitorSpinBox->value(), 10);
monitorIdentEdit->setText("Monitor" + num);
fillScreenCombos();

}

void kxMain :: addServerLayout()
{
x->addSection("ServerLayout");
QString layoutNumber;
layoutNumber = layoutNumber.setNum(listBox16->count(), 10);
x->saveValue("ServerLayout", x->sectionCount("ServerLayout"), "Identifier", 1, "Layout" + layoutNumber);
fillServerLayout();
listBox16->setSelected(listBox16->count() - 1, TRUE);
int a = 1;
LayoutsCombo->clear();
while (a <= x->sectionCount("ServerLayout"))
{
LayoutsCombo->insertItem(x->getValue("ServerLayout", a, "Identifier", 1));
a++;
}
}

void kxMain :: changeServerLayoutName()
{
QString newSrvLayName = KInputDialog::getText(locRet(3), locRet(4), "", 0, this);

if (newSrvLayName != "")
{
listBox16->changeItem(newSrvLayName, listBox16->currentItem());
x->saveValue("ServerLayout", listBox16->currentItem() + 1, "Identifier", 1, newSrvLayName);
LayoutsCombo->clear();
int b = 1;
while (b <= x->sectionCount("ServerLayout"))
{
LayoutsCombo->insertItem(x->getValue("ServerLayout", b, "Identifier", 1));
b++;
}
LayoutsComboSave();
}

}

void kxMain :: removeMonitor()
{
if (x->sectionCount("Monitor") == 1)
{
QMessageBox::warning(this, "kX Generator", locRet(20));
return;
}

if (x->sectionCount("Monitor") > 1)
{
x->removeSection("Monitor", videoSpinBox->value());
fillMonitor();
fillScreenCombos();
}

}

void kxMain :: removeServerLayout()
{
if (x->sectionCount("ServerLayout") == 1)
{
QMessageBox::warning(this, "kX Generator", locRet(21));
return;
}

if (x->sectionCount("ServerLayout") > 1)
{
int a = listBox16->currentItem();
x->removeSection("ServerLayout", a + 1);
fillServerLayout();
listBox16->setSelected(a, TRUE);

int b = 1;
LayoutsCombo->clear();

while (b <= x->sectionCount("ServerLayout"))
{
LayoutsCombo->insertItem(x->getValue("ServerLayout", b, "Identifier", 1));
b++;
}

LayoutsCombo->setCurrentItem(a - 1);
if (a == listBox16->count()) { listBox16->setSelected(a - 1, TRUE); }
LayoutsComboSave();
}


}

void kxMain :: addModuleToList()
{
unsigned int a = 0;
while (a <= modulesBox->count())
{
if (modulesBox->text(a) == moduleComboBox->text(moduleComboBox->currentItem()))
{
QMessageBox::warning(this, "kX Generator", locRet(22));
return;
}
a++;
}
modulesBox->insertItem(moduleComboBox->text(moduleComboBox->currentItem()));
x->addModule(moduleComboBox->text(moduleComboBox->currentItem()));
modulesBox->setSelected(modulesBox->count() - 1, TRUE);
}

void kxMain :: removeModuleFromList()
{
int a = modulesBox->currentItem();
x->removeModule(modulesBox->text(a));
modulesBox->removeItem(a);
if (a == modulesBox->count()) { modulesBox->setSelected(modulesBox->count() - 1, TRUE); }
if (a < modulesBox->count()) { modulesBox->setSelected(a, TRUE); }


}

void kxMain :: fillServerLayoutComponents()
{

listBox23->clear();
listBox23_2->clear();
listBox23_2_2->clear();
//*******
//Screens
//*******
QString screens = x->getSrvLayScreens(listBox16->currentItem() + 1);
int a = 0;
while (a > -1)
{
if (screens.section("|", a, a) == "") { break; }
listBox23->insertItem(screens.section("|", a, a).section("-", 1, 1));
a++;
}


//**********
//Mouse
//**********
QString mouse = x->getMouseList();
int b = 1;
while (b > -1)
{
a = 0;
   while (b > -1)
   {
   if (mouse.section("|", a, a) == "") { break; }
   if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == mouse.section("|", a, a))
   {
   listBox23_2->insertItem(mouse.section("|", a, a));
   break;
   }
   a++;
   }
if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == "") { break; }
b++;
}
//*********
//Keyboard
//*********
QString keyboard = x->getKeyboardList();

b = 1;
while (b > -1)
{
a = 0;
   while (b > -1)
   {
   if (keyboard.section("|", a, a) == "") { break; }
   if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == keyboard.section("|", a, a))
   {
   listBox23_2_2->insertItem(keyboard.section("|", a, a));
   break;
   }
   a++;
   }
if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == "") { break; }
b++;
}
listBox23->setSelected(0, TRUE);
listBox23_2->setSelected(0, TRUE);
listBox23_2_2->setSelected(0, TRUE);


if (listBox23->count() == 0) { removeSrvLayScreenButton->setEnabled(FALSE); }
if (listBox23->count() > 0) { removeSrvLayScreenButton->setEnabled(TRUE); }

if (listBox23_2->count() == 0) { removeSrvLayMouseButton->setEnabled(FALSE); }
if (listBox23_2->count() > 0) { removeSrvLayMouseButton->setEnabled(TRUE); }

if (listBox23_2_2->count() == 0) { removeSrvLayKeyboardButton->setEnabled(FALSE); }
if (listBox23_2_2->count() > 0) { removeSrvLayKeyboardButton->setEnabled(TRUE); }





}


void kxMain :: fillMouseKbd()
{




//**************************************
//Mouse tab
//**************************************



//Saving checkBox

//					Identifier & spin box
pointerSpinBox->setMaxValue(x->pointerCount());
mouseIdentLineEdit->setText(x->getValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Identifier", 1));
//					Driver
int a = 0;
while (a < comboBox3->count())
{
if (comboBox3->text(a).section(" - ", 0, 0) == x->getValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Driver", 1))
  {
   comboBox3->setCurrentItem(a);
   a = 32000;
   break;
  }
a++;
}
if (a != 32000)
{
comboBox3->insertItem(x->getValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Driver", 1));
comboBox3->setCurrentItem(comboBox3->count() - 1);
}


//					Device
if (x->getOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device") != "")
{
checkBox4->setChecked(FALSE);
mouseDeviceLineEdit->setText(x->getOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device"));
}

if (x->getOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device") == "")
{
checkBox4->setChecked(TRUE);
}


//****************************************
//Keyboard tab
//****************************************
kbdSpinBox->setMaxValue(x->kbdCount());
kbdIdentLineEdit->setText(x->getValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Identifier", 1));
QString getOption(QString sectionName, int sectionNumber, QString OptionName);

//Driver
a = 0;
while (a < comboBox6->count())
{
if (comboBox6->text(a).section(" - ", 0, 0) == x->getValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Driver", 1))
  {
   comboBox6->setCurrentItem(a);
   a = 32000;
   break;
  }
a++;
}
if (a != 32000)
{
comboBox6->insertItem(x->getValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Driver", 1));
comboBox6->setCurrentItem(comboBox6->count() - 1);
}


















//XKBModel

QString xkbModel = x->getOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel");
bool valExists = x->valExists("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel");
if (!valExists) { checkBox40->setChecked(TRUE); }

if (valExists) 
{
checkBox40->setChecked(FALSE);
int a = 0;
while (a < comboBox9->count())
{
if (xkbModel == comboBox9->text(a)) { comboBox9->setCurrentItem(a); a = 30000; break; }
a++;
}
if (a != 30000) { comboBox9->insertItem(xkbModel); comboBox9->setCurrentItem(comboBox9->count() - 1); }
}

//XKBLayout

QString xkbLayout = x->getOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbLayout");


a = 0;
while (a < comboBox10->count())
{
if (xkbLayout == comboBox10->text(a).section(" - ", 0, 0)) { comboBox10->setCurrentItem(a); a = 30000; break; }
a++;
}
if (a != 30000) { comboBox10->setCurrentItem(0); }



//Labels
QString pointerNum = "";
QString kbdNum = "";

if (x->pointerCount() == 1) { textLabel3_3->setText(locRet(23)); }
if (x->pointerCount() > 1) { 
pointerNum = pointerNum.setNum(x->pointerCount(), 10);
textLabel3_3->setText(pointerNum + locRet(18));
}

if (x->kbdCount() == 1) { textLabel4_4->setText(locRet(23)); }
if (x->kbdCount() > 1) { 
kbdNum = kbdNum.setNum(x->kbdCount(), 10);
textLabel4_4->setText(kbdNum + locRet(18));
}




x->mouseIdentBuf[pointerSpinBox->value()] = mouseIdentLineEdit->text();
x->kbdIdentBuf[kbdSpinBox->value()] = kbdIdentLineEdit->text();



}

void kxMain :: addPointer()
{
x->addSection("InputDevice");
x->addInputDriver("mouse");
fillMouseKbd();
pointerSpinBox->setValue(pointerSpinBox->maxValue());
QString num;
num = num.setNum(pointerSpinBox->value(), 10);
mouseIdentLineEdit->setText("Mouse" + num);
}

void kxMain :: addKeyboard()
{
x->addSection("InputDevice");
x->addInputDriver("keyboard");
fillMouseKbd();
kbdSpinBox->setValue(kbdSpinBox->maxValue());
QString num;
num = num.setNum(kbdSpinBox->value(), 10);
kbdIdentLineEdit->setText("Keyboard" + num);
}

void kxMain :: removeMouse()
{
if (x->pointerCount() == 1)
{
QMessageBox::warning(this, "kX Generator", locRet(24));
return;
}

QString ident = mouseIdentLineEdit->text();

if (x->pointerCount() > 1)
{
x->removeSection("InputDevice", x->pointerTranslate(pointerSpinBox->value()));
fillMouseKbd();
}
int xx = 1;
while (xx <= x->sectionCount("ServerLayout"))
{
x->removeSrvLayComp(xx, "InputDevice", ident);
xx++;
}


}

void kxMain :: removeKeyboard()
{
if (x->kbdCount() == 1)
{
QMessageBox::warning(this, "kX Generator", locRet(25));
return;
}

QString ident = kbdIdentLineEdit->text();

if (x->kbdCount() > 1)
{
x->removeSection("InputDevice", x->kbdTranslate(kbdSpinBox->value()));
fillMouseKbd();
}
int xx = 1;



while (xx <= x->sectionCount("ServerLayout"))
{
x->removeSrvLayComp(xx, "InputDevice", ident);
xx++;
}


}

void kxMain :: saveInputDrivers()
{
x->removeAllValues("InputDevice", x->pointerTranslate(pointerSpinBox->value()));
x->saveValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Driver", 1, comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0));
fillMouseKbd();
}


void kxMain :: saveInputDriversKbd()
{
x->removeAllValues("InputDevice", x->kbdTranslate(kbdSpinBox->value()));
x->saveValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Driver", 1, comboBox6->text(comboBox6->currentItem()).section(" - ", 0, 0));
fillMouseKbd();
}

void kxMain :: srvInputsPrepare()
{
int a = 0;
QString num;
QString option;
QString option2;

while (a < 1200)
{
num = num.setNum(a, 10);
x->replaceSomething("Screen " + num + " ", "Screen ");
a++;
}
a = 1;



//Pointers
while (a <= x->pointerCount())
{
num = x->getSecUniqueNum("InputDevice", x->pointerTranslate(a));
option = "InputDevice \"" + x->getValue("InputDevice", x->pointerTranslate(a), "Identifier", 1) + "\"";
option2 = "InputDevice \"" + num + "-" + x->getValue("InputDevice", x->pointerTranslate(a), "Identifier", 1) + "\"";
x->replaceSomething(option, option2);
a++;
}


//Keyboards
a = 1;
while (a <= x->kbdCount())
{
num = x->getSecUniqueNum("InputDevice", x->kbdTranslate(a));
option = "InputDevice \"" + x->getValue("InputDevice", x->kbdTranslate(a), "Identifier", 1) + "\"";
option2 = "InputDevice \"" + num + "-" + x->getValue("InputDevice", x->kbdTranslate(a), "Identifier", 1) + "\"";
x->replaceSomething(option, option2);
a++;
}

//Screens
int screen = 1;
int srvLay = 1;
QString srvLaySection;
QString scrName;


while (srvLay <= x->sectionCount("ServerLayout"))
{
srvLaySection = x->section("ServerLayout", srvLay);
screen = 1;
while (screen <= x->sectionCount("Screen"))
{
scrName = x->getValue("Screen", screen, "Identifier", 1);
num = x->getSecUniqueNum("Screen",screen);
srvLaySection = srvLaySection.replace("\"" + scrName + "\"", "\"" + num + "-" + scrName + "\"");
x->replaceSomething(x->section("ServerLayout", srvLay), srvLaySection);
screen++;
}





srvLay++;
}


}

void kxMain :: fillScreen()
{
int a = 0;
modeListBox->clear();
depthListBox->clear();
QString modes;

if(x->getDefaultDepth(scrSpinBox->value()) == "8") { defaultDepthCombo->setCurrentItem(0); }
if(x->getDefaultDepth(scrSpinBox->value()) == "16") { defaultDepthCombo->setCurrentItem(1); }
if(x->getDefaultDepth(scrSpinBox->value()) == "24") { defaultDepthCombo->setCurrentItem(2); }
if(x->getDefaultDepth(scrSpinBox->value()) == "32") { defaultDepthCombo->setCurrentItem(3); }

if (x->haveDepth(scrSpinBox->value(), "8")) { depthListBox->insertItem("8 bpp"); }
if (x->haveDepth(scrSpinBox->value(), "16")) { depthListBox->insertItem("16 bpp"); }
if (x->haveDepth(scrSpinBox->value(), "24")) { depthListBox->insertItem("24 bpp"); }
if (x->haveDepth(scrSpinBox->value(), "32")) { depthListBox->insertItem("32 bpp"); }


depthListBox->setSelected(0, TRUE);


QString num;
int numSecs = x->sectionCount("Screen");
scrSpinBox->setMaxValue(numSecs);
num = num.setNum(numSecs, 10);
if (numSecs == 1) { scrSpinLabel->setText(num + tr(" entry")); }
if (numSecs > 1) { scrSpinLabel->setText(num + tr(" entries")); }


//Identifier

screenIdentEdit->setText(x->getValue("Screen", scrSpinBox->value(), "Identifier", 1));
//Device
a = 0;
while (a < scrDevicesCombo->count())
{
if (x->getValue("Screen", scrSpinBox->value(), "Device", 1) == scrDevicesCombo->text(a)) { scrDevicesCombo->setCurrentItem(a); break; }
a++;
}


//Monitor
a = 0;
while (a < scrMonitorsCombo->count())
{
if (x->getValue("Screen", scrSpinBox->value(), "Monitor", 1) == scrMonitorsCombo->text(a)) { scrMonitorsCombo->setCurrentItem(a); break; }
a++;
}



}

void kxMain :: fillScreenCombos()
{
int a = 1;
scrMonitorsCombo->clear();
while (a <= x->sectionCount("Monitor"))
{
scrMonitorsCombo->insertItem(x->getValue("Monitor", a, "Identifier", 1));
a++;
}

a = 1;
scrDevicesCombo->clear();
while (a <= x->sectionCount("Device"))
{
scrDevicesCombo->insertItem(x->getValue("Device", a, "Identifier", 1));
a++;
}



}

void kxMain :: updateScreenModes()
{
int a = 0;
modeListBox->clear();
QString modes = x->getModes(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0));
while (a > -1)
{
if (modes.section("|", a, a) == "") { break; }
modeListBox->insertItem(modes.section("|", a, a));
a++;
}



modeListBox->setSelected(0, TRUE);
}

void kxMain :: removeScreenMode()
{
x->removeMode(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0), modeListBox->text(modeListBox->currentItem()));
int cnt = modeListBox->currentItem();
updateScreenModes();
if (cnt < modeListBox->count()) { modeListBox->setSelected(cnt, TRUE); }
if (cnt > modeListBox->count()) { modeListBox->setSelected(cnt - 1, TRUE); }
if (cnt == modeListBox->count()) { modeListBox->setSelected(cnt - 1, TRUE); }
}

void kxMain :: addScreenMode()
{
//Checking if mode is already on the list
int a = 0;
while (a <= modeListBox->count())
{
if (modeListBox->text(a) == modeComboBox->text(modeComboBox->currentItem())) 
{
QMessageBox::information(this, "kX Generator", locRet(26));
return;
}
a++;

}

x->addMode(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0), modeComboBox->text(modeComboBox->currentItem()));
updateScreenModes();
modeListBox->setSelected(modeListBox->count() - 1, TRUE);
}

void kxMain :: saveScreenMonitor()
{
x->saveValue("Screen", scrSpinBox->value(), "Monitor", 1, scrMonitorsCombo->text(scrMonitorsCombo->currentItem()));
}

void kxMain :: saveScreenDevice()
{
x->saveValue("Screen", scrSpinBox->value(), "Device", 1, scrDevicesCombo->text(scrDevicesCombo->currentItem()));
}

void kxMain :: removeScreenDepth()
{
bool deleteDef = false;
QString defDepth = x->getDefaultDepth(scrSpinBox->value());
if (depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0) == defDepth) { deleteDef = true; }
x->removeDepth(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0));
int cnt = depthListBox->currentItem();
fillScreen();
if (cnt < depthListBox->count()) { depthListBox->setSelected(cnt, TRUE); }
if (cnt > depthListBox->count()) { depthListBox->setSelected(cnt - 1, TRUE); }
if (cnt == depthListBox->count()) { depthListBox->setSelected(cnt - 1, TRUE); }
if (deleteDef) 
{
if (depthListBox->text(depthListBox->currentItem()) == "8 bpp") { defaultDepthCombo->setCurrentItem(0); }
if (depthListBox->text(depthListBox->currentItem()) == "16 bpp") { defaultDepthCombo->setCurrentItem(1); }
if (depthListBox->text(depthListBox->currentItem()) == "24 bpp") { defaultDepthCombo->setCurrentItem(2); }
if (depthListBox->text(depthListBox->currentItem()) == "32 bpp") { defaultDepthCombo->setCurrentItem(3); }
}
}

void kxMain :: saveDefaultDepth()
{
if (x->haveDepth(scrSpinBox->value(), defaultDepthCombo->text(defaultDepthCombo->currentItem()).section(" bpp", 0, 0)))
{
x->saveDefaultDepth(scrSpinBox->value(), defaultDepthCombo->text(defaultDepthCombo->currentItem()).section(" bpp", 0, 0));
}
else
{
if (x->haveDepth(scrSpinBox->value(), "8")) { defaultDepthCombo->setCurrentItem(0); }
if (x->haveDepth(scrSpinBox->value(), "16")) { defaultDepthCombo->setCurrentItem(1); }
if (x->haveDepth(scrSpinBox->value(), "24")) { defaultDepthCombo->setCurrentItem(2); }
if (x->haveDepth(scrSpinBox->value(), "32")) { defaultDepthCombo->setCurrentItem(3); }
}
}

void kxMain :: addDepth()
{
//Checking if mode is already on the list
int a = 0;
while (a <= depthListBox->count())
{
if (depthListBox->text(a) == depthComboBox->text(depthComboBox->currentItem())) 
{
QMessageBox::information(this, "kX Generator", locRet(27));
return;
}
a++;

}

x->addDepth(scrSpinBox->value(), depthComboBox->text(depthComboBox->currentItem()).section(" bpp", 0, 0));
fillScreen();
depthListBox->setSelected(depthListBox->count() - 1, TRUE);
}

void kxMain :: addLayScreen()
{
QStringList screensList;
int a = 1;
while (a <= x->sectionCount("Screen"))
{
screensList.append(x->getValue("Screen", a, "Identifier", 1));
a++;
}
QString selected = KInputDialog::getItem(locRet(5), locRet(6), screensList, 0, false, 0, this);
if (selected == "") { return; }
a = 0;
while (a <= listBox23->count())
{
if (selected == listBox23->text(a))
{
KMessageBox::sorry(this, locRet(7), "kX Generator", KMessageBox::Notify); return;
}
a++;
}
x->addScreen(listBox16->currentItem() + 1, selected);
fillServerLayoutComponents();
listBox23->setSelected(listBox23->count() - 1, TRUE);
}

void kxMain :: removeSrvScreen()
{
x->removeSrvLayComp(listBox16->currentItem() + 1, "Screen", listBox23->text(listBox23->currentItem()));



int cnt = listBox23->currentItem();
fillServerLayoutComponents();
listBox23->setSelected(cnt, TRUE);
if (cnt == listBox23->count()) { listBox23->setSelected(cnt - 1, TRUE); }
}

void kxMain :: addSrvPointer()
{
QStringList pointerList;
int a = 1;
while (a <= x->pointerCount())
{
pointerList.append(x->getValue("InputDevice", x->pointerTranslate(a), "Identifier", 1));
a++;
}
QString selected = KInputDialog::getItem(locRet(8), locRet(9), pointerList, 0, false, 0, this);
if (selected == "") { return; }
a = 0;

while (a <= listBox23_2->count())
{
if (selected == listBox23_2->text(a))
{
KMessageBox::sorry(this, locRet(10), "kX Generator", KMessageBox::Notify); return;
}
a++;
}
x->addPointer(listBox16->currentItem() + 1, selected);
fillServerLayoutComponents();
listBox23_2->setSelected(listBox23_2->count() - 1, TRUE);

}

void kxMain :: removeSrvPointer()
{
x->removeSrvLayComp(listBox16->currentItem() + 1, "InputDevice", listBox23_2->text(listBox23_2->currentItem()));
int cnt = listBox23_2->currentItem();
fillServerLayoutComponents();
listBox23_2->setSelected(cnt, TRUE);
if (cnt == listBox23_2->count()) { listBox23_2->setSelected(cnt - 1, TRUE); }

}

void kxMain :: addSrvKeyboard()
{
QStringList keyboardsList;
int a = 1;
while (a <= x->kbdCount())
{
keyboardsList.append(x->getValue("InputDevice", x->kbdTranslate(a), "Identifier", 1));
a++;
}
QString selected = KInputDialog::getItem(locRet(11), locRet(12), keyboardsList, 0, false, 0, this);
if (selected == "") { return; }
a = 0;

while (a <= listBox23_2_2->count())
{
if (selected == listBox23_2_2->text(a))
{
KMessageBox::sorry(this, locRet(13), "kX Generator", KMessageBox::Notify); return;
}
a++;
}
x->addKeyboard(listBox16->currentItem() + 1, selected);
fillServerLayoutComponents();
listBox23_2_2->setSelected(listBox23_2_2->count() - 1, TRUE);

}

void kxMain :: removeSrvKeyboard()
{
x->removeSrvLayComp(listBox16->currentItem() + 1, "InputDevice", listBox23_2_2->text(listBox23_2_2->currentItem()));
int cnt = listBox23_2_2->currentItem();
fillServerLayoutComponents();
listBox23_2_2->setSelected(cnt, TRUE);
if (cnt == listBox23_2_2->count()) { listBox23_2_2->setSelected(cnt - 1, TRUE); }

}

void kxMain :: addScreen()
{
x->addSection("Screen");
QString screenNumber;
screenNumber = screenNumber.setNum(x->sectionCount("Screen"), 10);
x->saveValue("Screen", x->sectionCount("Screen"), "Identifier", 1, "Screen" + screenNumber);
x->saveValue("Screen", x->sectionCount("Screen"), "Device", 1, x->getValue("Device", 1, "Identifier", 1));
x->saveValue("Screen", x->sectionCount("Screen"), "Monitor", 1, x->getValue("Monitor", 1, "Identifier", 1));
fillScreen();
scrSpinBox->setValue(x->sectionCount("Screen"));

}

void kxMain :: removeScreen()
{

if (x->sectionCount("Screen") == 1)
{
QMessageBox::warning(this, "kX Generator", locRet(28));
return;
}
QString ident = screenIdentEdit->text();

if (x->sectionCount("Screen") > 1)
{
x->removeSection("Screen", scrSpinBox->value());
fillScreen();
}

int xx = 1;
while (xx <= x->sectionCount("ServerLayout"))
{
x->removeSrvLayComp(xx, "Screen", ident);
xx++;
}
fillServerLayoutComponents();


}

void kxMain::showGlobalDpmsSettings()
{
DPMSGlobalDialog *globalDPMS = new DPMSGlobalDialog(this, "Global DPMS Dialog", x->returnConfig(), "ServerFlags", 1);
globalDPMS->exec();
x->saveXorg(globalDPMS->returnXorg());
delete globalDPMS;
}

void kxMain::modifyGamma()
{
GammaDialogClass *gammaDialog = new GammaDialogClass (this, "Gamma Dialog", monitorSpinBox->value(), x->returnConfig());
gammaDialog->exec();
x->saveXorg(gammaDialog->returnXorg());
delete gammaDialog;
}



void kxMain :: fillInputIdentBufs()
{


}

void kxMain::resetConfiguration()
{
x->reset();
modulesBox->clear();
modulesPathListBox->clear();
RGBPathRequester->clear();
fontsBox->clear();
initCheckboxes();
srvInputsPrepare();
fillVideocard();
fillMonitor();
fillModules();
fillFiles();
fillServerLayout();
fillMouseKbd();
fillScreenCombos();
fillScreen();


}

void kxMain::modifyServerLayoutDPMS()
{
DPMSGlobalDialog *globalDPMS = new DPMSGlobalDialog(this, "Global DPMS Dialog", x->returnConfig(), "ServerLayout", listBox16->currentItem() + 1);
globalDPMS->exec();
x->saveXorg(globalDPMS->returnXorg());
delete globalDPMS;
}

void kxMain::srvFlagsCheck()
{
if (ServerFlagsContainer->isChecked()) { 
if (x->sectionCount("ServerFlags") == 0) { x->addSection("ServerFlags"); }
}
if (!ServerFlagsContainer->isChecked()) { x->removeSection("ServerFlags", 1); }
}

void kxMain::advSrvFlagsGeneral()
{
advancedServerFlagsClass *advFlagsGeneral = new advancedServerFlagsClass(this, "Advanced Server Flag Options - general", "ServerFlags", -1, x->returnConfig(), -1);
advFlagsGeneral->exec();
x->saveXorg(advFlagsGeneral->returnXFile());
}

void kxMain::srvLayoutFlagsAdvanced()
{
advancedServerFlagsClass *advFlagsGeneral = new advancedServerFlagsClass(this, "Advanced Server Flag Options - ServerLayout", "ServerLayout", listBox16->currentItem() + 1, x->returnConfig(), -1);
advFlagsGeneral->exec();
x->saveXorg(advFlagsGeneral->returnXFile());
}

void kxMain::addNewModule()
{
QString moduleName = KInputDialog::getText(locRet(1), locRet(2), "", 0, this);

if (moduleName != "") { moduleComboBox->insertItem(moduleName); }

}

void kxMain::commentChange()
{
if (commentCheckBox->isChecked()) { commentEdit->setEnabled(TRUE); }
if (!commentCheckBox->isChecked()) { commentEdit->setEnabled(FALSE); }
}

void kxMain::advancedKeyboardOptions()
{
if (comboBox6->text(comboBox6->currentItem()).section(" - ", 0, 0) == "keyboard" || comboBox6->text(comboBox6->currentItem()).section(" - ", 0, 0) == "kbd") 
{
kbdOptionsDialog *kbd = new kbdOptionsDialog(this, "Keyboard options dialog", x->returnConfig(), x->kbdTranslate(kbdSpinBox->value()));
kbd->exec();
x->saveXorg(kbd->returnXorg());
return;
}
KMessageBox::sorry(this, locRet(14), "kX Generator", KMessageBox::Notify); return;
}


void kxMain::advPointerOptionsDialog()
{
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "mouse")
{
mouseDriverDialog *mouseDrvDialog = new mouseDriverDialog(this, "mouse driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
mouseDrvDialog->exec();
x->saveXorg(mouseDrvDialog->returnXorg());
return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "wacom")
{
wacomDrvDialogClass *wacomDrvDialog = new wacomDrvDialogClass(this, "wacom driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
wacomDrvDialog->exec();
x->saveXorg(wacomDrvDialog->returnXorg());
fillMouseKbd();
return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "tek4957")
{
tk4957dialogoptions *tek = new tk4957dialogoptions(this, "tek4957 driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
tek->exec();
x->saveXorg(tek->returnXorg());
fillMouseKbd();
return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "aiptek")
{
aiptekDriverClass *aiptek = new aiptekDriverClass(this, "tek4957 driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
aiptek->exec();
x->saveXorg(aiptek->returnXorg());
fillMouseKbd();
return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "elographics")
{
elographicsDriverClass *elo = new elographicsDriverClass(this, "elographics driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
elo->exec();
x->saveXorg(elo->returnXorg());
fillMouseKbd();
return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "fpit")
{
fpitDriverClass *fpit = new fpitDriverClass(this, "fpit driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
fpit->exec();
x->saveXorg(fpit->returnXorg());
fillMouseKbd();
return;
}

if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "js_x")
{
jsxDriverClass *jsx = new jsxDriverClass(this, "js_x driver dialog", x->returnConfig(), x->pointerTranslate(pointerSpinBox->value()));
jsx->exec();
x->saveXorg(jsx->returnXorg());
fillMouseKbd();
return;
}









if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "penmount")
{
KMessageBox::sorry(this, locRet(29), "kX Generator", KMessageBox::Notify); return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "mutouch")
{
KMessageBox::sorry(this, locRet(29), "kX Generator", KMessageBox::Notify); return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "void")
{
KMessageBox::sorry(this, locRet(29), "kX Generator", KMessageBox::Notify); return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "dmc")
{
KMessageBox::sorry(this, locRet(29), "kX Generator", KMessageBox::Notify); return;
}
if (comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0) == "dynapro")
{
KMessageBox::sorry(this, locRet(29), "kX Generator", KMessageBox::Notify); return;
}




KMessageBox::sorry(this, locRet(15), "kX Generator", KMessageBox::Notify); return;
}

void kxMain :: changeDPMSOption()
{
if (checkBox16->isChecked())
{
x->saveOption("Monitor", monitorSpinBox->value(), "DPMS", 1, "True");
}
if (!checkBox16->isChecked())
{
x->removeOption("Monitor", monitorSpinBox->value(), "DPMS");
}
}

void kxMain :: deviceAdvanced()
{
if (videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0) == "nvidia")
{
nvidiaDriverOptionsBigDialog *nvdialog = new nvidiaDriverOptionsBigDialog(this, "NVIDIA driver dialog", x->returnConfig(), videoSpinBox->value());
nvdialog->exec();
x->saveXorg(nvdialog->returnXorg());
return;
}
if (videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0) == "nv")
{
nvDriverDialogClass *nvdialog = new nvDriverDialogClass(this, "NVIDIA driver dialog", x->returnConfig(), videoSpinBox->value());
nvdialog->exec();
x->saveXorg(nvdialog->returnXorg());
return;
}
if (videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0) == "vesa")
{
vesaDialogClass *vesa = new vesaDialogClass(this, "VESA driver dialog", x->returnConfig(), videoSpinBox->value());
vesa->exec();
x->saveXorg(vesa->returnXorg());
return;
}
if (videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0) == "fbdev")
{
fbDevDialogClass *fb = new fbDevDialogClass(this, "FbDev driver dialog", x->returnConfig(), videoSpinBox->value());
fb->exec();
x->saveXorg(fb->returnXorg());
return;
}
if (videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0) == "via")
{
viaDriverClass *via = new viaDriverClass(this, "VIA driver dialog", x->returnConfig(), videoSpinBox->value());
via->exec();
x->saveXorg(via->returnXorg());
return;
}






KMessageBox::sorry(this, locRet(16), "kX Generator", KMessageBox::Notify); return;


}


void kxMain :: checkExtensions()
{
if (!checkBox8->isChecked() && !checkBox4_2->isChecked())
{
x->removeSection("Extensions", 1);
return;
}
if (checkBox8->isChecked() || checkBox4_2->isChecked())
{
if (x->sectionCount("Extensions") == 0) { x->addSection("Extensions"); }
if (checkBox8->isChecked()) { x->saveOption("Extensions", 1, "Xinerama", 1, "True"); }
if (checkBox4_2->isChecked()) { x->saveOption("Extensions", 1, "Composite", 1, "True"); }
if (!checkBox8->isChecked()) { x->removeOption("Extensions", 1, "Xinerama"); }
if (!checkBox4_2->isChecked()) { x->removeOption("Extensions", 1, "Composite"); }
}






}








void kxMain::addModulePath()
{
QString toEnter = KFileDialog :: getExistingDirectory (QDir::homeDirPath(), this, tr("Choose modules path"));
if (toEnter != "") { modulesPathListBox->insertItem(toEnter); }
}

void kxMain::removeModulesDir()
{
int a = modulesPathListBox->currentItem();
modulesPathListBox->removeItem(a);
modulesPathListBox->setSelected(a, TRUE);
if (a == modulesPathListBox->count()) { modulesPathListBox->setSelected(a - 1, TRUE); }
if (a == 0) { modulesPathListBox->setSelected(0, TRUE); }

}

void kxMain::addFontsDir()
{

if (customFontLineEdit->text() == "")
{
QString toEnter = KFileDialog :: getExistingDirectory (QDir::homeDirPath(), this, tr("Choose fonts path"));
if (toEnter != "") { fontsBox->insertItem(toEnter); }
}

if (customFontLineEdit->text() != "")
{
fontsBox->insertItem(customFontLineEdit->text());
customFontLineEdit->setText("");
}

}

void kxMain::removeFontsDir()
{
int a = fontsBox->currentItem();
fontsBox->removeItem(a);
fontsBox->setSelected(a, TRUE);
if (a == fontsBox->count()) { fontsBox->setSelected(a - 1, TRUE); }
if (a == 0) { fontsBox->setSelected(0, TRUE); }
}




void kxMain :: modifyDisplaySub()
{


}


void kxMain :: screenAdvancedButton()
{
advancedMonitorDialogClass *monitorAdvanced = new advancedMonitorDialogClass(this, "Advanced Monitor Settings Dialog", x->returnConfig(), monitorSpinBox->value());
monitorAdvanced->exec();
x->saveXorg(monitorAdvanced->returnXorg());

}




void kxMain :: videoDriverHelp()
{
QString driver = videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0);
helpBoxInformation *helpBox = new helpBoxInformation(this, "HelpBox", driver);
helpBox->exec();
}

void kxMain :: mouseDriverHelp()
{
QString driver = comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0);
helpBoxInformation *helpBox = new helpBoxInformation(this, "HelpBox", driver);
helpBox->exec();
}

void kxMain :: keyboardDriverHelp()
{
QString driver = comboBox6->text(comboBox6->currentItem()).section(" - ", 0, 0);
helpBoxInformation *helpBox = new helpBoxInformation(this, "HelpBox", driver);
helpBox->exec();
}




#include "kxmain.moc"
