/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KXMAIN_H
#define KXMAIN_H
#include "kxgeneratormain.h"
#include "xorg.h"



//QT Includes

#include <qfile.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qmessagebox.h>
#include <qdir.h>



//KDE Includes

#include <kfiledialog.h>
#include <kprocess.h>
#include <kinputdialog.h>
#include <kpushbutton.h>
#include <kdialogbase.h>
#include <kcombobox.h>
#include <kurlrequester.h>
#include <knuminput.h>
#include <klistbox.h>
#include <klineedit.h>
#include <ktextedit.h>
#include <ktabwidget.h>
#include <kactivelabel.h>
#include <ksqueezedtextlabel.h>
#include <klocale.h>
#include <kmessagebox.h>




class kxMain: public Form1 {
Q_OBJECT
public:
    kxMain(QWidget *parent = 0, const char *name = 0);

    xorgConf *x;
    void fillModules();
//KProcess *saveFileProcess;




public slots:
    void Generate();
    void setLocale();
    void fillInputIdentBufs();
    void fillMonitor();
    void fillVideocard();
    void fillServerLayout();
    void aboutDialog();
    void fillFiles();
    void mouseIdentLineEditHandle();
    void mouseDeviceLineEditHandle();
    void kbdIdentLineEditHandle();
    void showDebug();
    void removeDevice();
    void monitorVendorEditHandle();
    void monitorModelEditHandle();
    void monitorIdentEditHandle();
    void videoVendorEditHandle();
    void videoIdentEditHandle();
    void removeModuleFromList();
    void addModuleToList();
    void removeServerLayout();
    void removeMonitor();
    void addServerLayout();
    void addDevice();
    void changeServerLayoutName();
    void addMonitor();
    void videoComboBoxHandle();
    void fillServerLayoutComponents();
    void fillMouseKbd();
    void mouseDeviceCheckBoxHandle();
    void devMouseCheckBoxSave();
    void saveInputDrivers();
    void removeKeyboard();
    void removeMouse();
    void addKeyboard();
    void addPointer();
    void xkbLayoutComboHandle();
    void xkbModelCheckClicked();
    void xkbModelComboHandle();
    void xkbModelCheckBoxHandle();
    void srvInputsPrepare();
    void removeFontsDir();
    void addFontsDir();
    void removeModulesDir();
    void addModulePath();
    void fillScreen();
    void fillScreenCombos();
    void scrIdenEditHanle();
    void updateScreenModes();
    void removeScreenDepth();
    void saveScreenDevice();
    void removeSrvKeyboard();
    void addSrvKeyboard();
    void removeSrvPointer();
    void addSrvPointer();
    void removeSrvScreen();
    void addLayScreen();
    void saveScreenMonitor();
    void addScreenMode();
    void removeScreenMode();
    void addDepth();
    void saveDefaultDepth();
    void removeScreen();
    void addScreen();
    void initCheckboxes();
    void showGlobalDpmsSettings();
    void modifyGamma();
    void saveServerFlagsCheckBoxes();
    void resetConfiguration();
    void srvFlagsCheck();
    void commentChange();
    void modifyServerLayoutDPMS();
    void LayoutsComboSave();
    void defSrvLayContChange();
    void saveSrvLayoutFlags();
    void srvLayoutFlagsAdvanced();
    void srvLayoutFlagsInit();
    void showInfo();
    void advSrvFlagsGeneral();
    void addNewModule();
    QString locRet(int number);
    void advancedKeyboardOptions();
    void advPointerOptionsDialog();
    void changeDPMSOption();
    void deviceAdvanced();
    void checkExtensions();
    void modifyDisplaySub();
    void screenAdvancedButton();
    void videoDriverHelp();
    void mouseDriverHelp();
    void keyboardDriverHelp();
    void saveInputDriversKbd();
    bool checkOk(QString x);
};

#endif
