/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nvdriverdialogclass.h"
#include <qradiobutton.h>

nvDriverDialogClass::nvDriverDialogClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :nv_drv_options(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
setLocale();
if (x->getOption("Device", sectNum, "CrtcNumber") != "")
{
checkBox18->setChecked(TRUE);
bool ok;
int num = x->getOption("Device", sectNum, "CrtcNumber").toInt(&ok, 10);
spinBox3->setValue(num);
}
if (x->checkOption("Device", sectNum, "HWCursor")) { checkBox14->setChecked(TRUE); }
if (!x->checkOption("Device", sectNum, "NoAccel")) { checkBox15->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "UseFBDev")) { checkBox17->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "ShadowFB")) { checkBox23->setChecked(TRUE); }
if (x->getOption("Device", sectNum, "Rotate") == "CW")
{
radioButton1->setChecked(TRUE);
radioButton2->setChecked(FALSE);
groupBox15->setChecked(TRUE);
}
if (x->getOption("Device", sectNum, "Rotate") == "CCW")
{
radioButton2->setChecked(TRUE);
radioButton1->setChecked(FALSE);
groupBox15->setChecked(TRUE);
}
if (x->checkOption("Device", sectNum, "FlatPanel")) 
{
groupBox14->setChecked(TRUE); 
}
if (x->checkOption("Device", sectNum, "FPDither")) 
{
groupBox14->setChecked(TRUE); 
checkBox19->setChecked(TRUE); 
}
if (x->checkOption("Device", sectNum, "FPScale")) 
{
groupBox14->setChecked(TRUE); 
checkBox20->setChecked(TRUE); 
}





}

QString nvDriverDialogClass :: returnXorg()
{
return x->returnConfig();
}

void nvDriverDialogClass::radioButton2Slot()
{
radioButton1->setChecked(FALSE);
radioButton2->setChecked(TRUE);
}


void nvDriverDialogClass::radioButton1Slot()
{
radioButton2->setChecked(FALSE);
radioButton1->setChecked(TRUE);
}

void nvDriverDialogClass::CRTCCheck()
{
if (checkBox18->isChecked()) { spinBox3->setEnabled(TRUE); }
if (!checkBox18->isChecked()) { spinBox3->setEnabled(FALSE); }
}

void nvDriverDialogClass :: accept()
{
QString y = "True";
if (checkBox18->isChecked())
{
QString num;
num = num.setNum(spinBox3->value(), 10);
x->saveOption("Device", sectNum, "CrtcNumber", 1, num);
}
if (!checkBox18->isChecked()) { x->removeOption("Device", sectNum, "CrtcNumber"); }




if (checkBox14->isChecked()) { x->saveOption("Device", sectNum, "HWCursor", 1, y); }
if (!checkBox14->isChecked()) { x->removeOption("Device", sectNum, "HWCursor"); }
if (!checkBox15->isChecked()) { x->saveOption("Device", sectNum, "NoAccel", 1, y); }
if (checkBox15->isChecked()) { x->removeOption("Device", sectNum, "NoAccel"); }
if (checkBox17->isChecked()) { x->saveOption("Device", sectNum, "UseFBDev", 1, y); }
if (!checkBox17->isChecked()) { x->removeOption("Device", sectNum, "UseFBDev"); }
if (checkBox23->isChecked()) { x->saveOption("Device", sectNum, "ShadowFB", 1, y); }
if (!checkBox23->isChecked()) { x->removeOption("Device", sectNum, "ShadowFB"); }

if (!groupBox15->isChecked())
{
x->removeOption("Device", sectNum, "Rotate");
}
if (groupBox15->isChecked())
{
if (radioButton1->isChecked()) { x->saveOption("Device", sectNum, "Rotate", 1, "CW"); }
if (radioButton2->isChecked()) { x->saveOption("Device", sectNum, "Rotate", 1, "CCW"); }
}

if (!groupBox14->isChecked())
{
x->removeOption("Device", sectNum, "FlatPanel");
x->removeOption("Device", sectNum, "FPDither");
x->removeOption("Device", sectNum, "FPScale");
}


if (groupBox14->isChecked())
{
x->saveOption("Device", sectNum, "FlatPanel", 1, y);
if (checkBox19->isChecked()) { x->saveOption("Device", sectNum, "FPDither", 1, y); }
if (checkBox20->isChecked()) { x->saveOption("Device", sectNum, "FPScale", 1, y); }
}



close();
}



#include "nvdriverdialogclass.moc"

