/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "wacomdrvdialogclass.h"

wacomDrvDialogClass::wacomDrvDialogClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :wacom_driver(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
setLocale();
if (x->getOption("InputDevice", sectNum, "Type") == "stylus") { comboBox12->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "Type") == "eraser") { comboBox12->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "Type") == "cursor") { comboBox12->setCurrentItem(2); }
if (x->checkOption("InputDevice", sectNum, "USB")) { checkBox7->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "Tilt")) { checkBox9->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "AlwaysCore")) { checkBox10->setChecked(TRUE); }

lineEdit14->setText(x->getOption("InputDevice", sectNum, "Device"));
lineEdit13->setText(x->getOption("InputDevice", sectNum, "DeviceName"));

if (x->getOption("InputDevice", sectNum, "Mode") == "Relative") { comboBox15->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "Mode") == "Absolute") { comboBox15->setCurrentItem(1); }

QString num = x->getOption("InputDevice", sectNum, "HistorySize");
bool ok;
int hSize = num.toInt(&ok, 10);
spinBox11->setValue(hSize);

if (x->checkOption("InputDevice", sectNum, "KeepShape")) { checkBox8->setChecked(TRUE); }
num = x->getOption("InputDevice", sectNum, "TopX");


int topX = num.toInt(&ok, 10);
spinBox7->setValue(topX);
num = x->getOption("InputDevice", sectNum, "TopY");
int topY = num.toInt(&ok, 10);
spinBox8->setValue(topY);
num = x->getOption("InputDevice", sectNum, "BottomX");
int bottomX = num.toInt(&ok, 10);
spinBox9->setValue(bottomX);
num = x->getOption("InputDevice", sectNum, "BottomY");
int bottomY = num.toInt(&ok, 10);
spinBox10->setValue(bottomY);
num = x->getOptionNoBrackets("InputDevice", sectNum, "DebugLevel");
int debugLevel = num.toInt(&ok, 10);
spinBox15->setValue(debugLevel);
num = x->getOption("InputDevice", sectNum, "Serial");
int serial = num.toInt(&ok, 10);
spinBox12->setValue(serial);
num = x->getOption("InputDevice", sectNum, "Threshold");
int threshold = num.toInt(&ok, 10);
spinBox12_2->setValue(threshold);

ok = false;
if (x->getOption("InputDevice", sectNum, "BaudRate") == "38400") { comboBox14->setCurrentItem(0); ok = true; }
if (x->getOption("InputDevice", sectNum, "BaudRate") == "19200") { comboBox14->setCurrentItem(1); ok = true; }
if (x->getOption("InputDevice", sectNum, "BaudRate") == "9600") { comboBox14->setCurrentItem(2); ok = true; }
if (!ok) { comboBox14->setCurrentItem(2); }

}

QString wacomDrvDialogClass :: returnXorg()
{
return x->returnConfig();
}


void wacomDrvDialogClass :: accept()
{
if (lineEdit14->text() == "") 
{ 
KMessageBox::sorry(this, locRet(1), "kX Generator", KMessageBox::Notify); return;
}

if (comboBox12->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "Type", 1, "stylus"); }
if (comboBox12->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Type", 1, "eraser"); }
if (comboBox12->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "Type", 1, "cursor"); }
if (lineEdit14->text() != "") { x->saveOption("InputDevice", sectNum, "Device", 1, lineEdit14->text()); }
if (lineEdit13->text() != "") { x->saveOption("InputDevice", sectNum, "DeviceName", 1, lineEdit13->text()); }
if (lineEdit13->text() == "") { x->removeOption("InputDevice", sectNum, "DeviceName"); }
if (comboBox14->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, "38400"); }
if (comboBox14->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, "19200"); }
if (comboBox14->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, "9600"); }
if (comboBox15->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "Mode", 1, "Relative"); }
if (comboBox15->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Mode", 1, "Absolute"); }

if (spinBox15->value() > 0)
{
QString num;
num = num.setNum(spinBox15->value(), 10);
x->removeOption("InputDevice", sectNum, "DebugLevel");
x->saveOptionNoBrackets("InputDevice", sectNum, "DebugLevel", 1, num);
}
if (spinBox7->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox7->value(), 10);
x->saveOption("InputDevice", sectNum, "TopX", 1, num);
}
if (spinBox8->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox8->value(), 10);
x->saveOption("InputDevice", sectNum, "TopY", 1, num);
}
if (spinBox9->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox9->value(), 10);
x->saveOption("InputDevice", sectNum, "BottomX", 1, num);
}
if (spinBox10->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox10->value(), 10);
x->saveOption("InputDevice", sectNum, "BottomY", 1, num);
}
if (spinBox11->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox11->value(), 10);
x->saveOption("InputDevice", sectNum, "HistorySize", 1, num);
}
if (spinBox12->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox12->value(), 10);
x->saveOption("InputDevice", sectNum, "Serial", 1, num);
}
if (spinBox12_2->value() > 0) 
{ 
QString num;
num = num.setNum(spinBox12_2->value(), 10);
x->saveOption("InputDevice", sectNum, "Threshold", 1, num);
}

if (checkBox8->isChecked()) { x->saveOption("InputDevice", sectNum, "KeepShape", 1, "on"); }
if (!checkBox8->isChecked()) { x->removeOption("InputDevice", sectNum, "KeepShape"); }
if (checkBox7->isChecked()) { x->saveOption("InputDevice", sectNum, "USB", 1, "on"); }
if (!checkBox7->isChecked()) { x->removeOption("InputDevice", sectNum, "USB"); }
if (checkBox9->isChecked()) { x->saveOption("InputDevice", sectNum, "Tilt", 1, "on"); }
if (!checkBox9->isChecked()) { x->removeOption("InputDevice", sectNum, "Tilt"); }
if (checkBox10->isChecked()) { x->saveOption("InputDevice", sectNum, "AlwaysCore", 1, "on"); }
if (!checkBox10->isChecked()) { x->removeOption("InputDevice", sectNum, "AlwaysCore"); }


close();
}



#include "wacomdrvdialogclass.moc"


